C     (Test fseek()/ftell())
C     Copy stdin to a scratch file, then use fseek() and ftell()
C     to copy it in byte-reversed order to a second scratch file,
C     which finally is copied to stdout in byte-reversed order.
C     If this works, the output should match the input.
C
C     To allow later checking, the intermediate files are written
C     to tstio9.tm1 and tstio9.tm2, instead of to 'scratch' files
C     which disappear at job end.
C     (17-Apr-86)
      integer    EOF, STDIN, STDOUT, TM1, TM2
      parameter  (EOF = -1)
      parameter  (STDIN = 5)
      parameter  (STDOUT = 6)
      parameter  (TM1 = 10)
      parameter  (TM2 = 11)
C
      integer    fseek
      integer*4  ftell, lenfil, offset
      integer    fgetc, fputc
      integer    k
      character  ch
C
      open (unit=TM1,access='sequential',form='formatted',
     x     status='unknown',file='tstio9.tm1')
      open (unit=TM2,access='sequential',form='formatted',
     x     status='unknown',file='tstio9.tm2')
C
C     Force the files to be opened for output.  FORTRAN must delay the
C     real open until the first READ or WRITE makes clear which fopen()
C     mode will be required.
C
      rewind TM1
      rewind TM2
C     write (TM1,*) ' This is TM1'
C     write (TM2,*) ' This is TM2'
C     rewind TM1
C     rewind TM2
C
C     Copy stdin to TM1.  We cannot use fseek() and ftell() on
C     stdin or stdout, so the scratch file is required.
C
      lenfil = 0
   10 k = fgetc(STDIN,ch)
      if (k .eq. EOF) go to 20
      k = fputc(TM1,ch)
      lenfil = lenfil + 1
      go to 10
C
C     Copy TM1 to TM2 in reverse order.
C
   20 call fflush(TM1)
      rewind TM1
C     close (unit = TM1)
      write (0,*) lenfil,' bytes copied from stdin to TM1'
C     open (unit=TM1,access='sequential',form='formatted',
C    x     status='old',file='tstio9.tm1')
C     rewind TM1
      offset = 0
      k = fseek(TM1,offset,2)
      lenfil = ftell(TM1)
      write (0,*) ' TM1 has ',lenfil,' bytes'
           do 30 offset = 1,lenfil
           k = fseek(TM1,-offset,2)
           if (k .eq. EOF) then
                write (*,*) '?fseek(TM1,',offset,',2) returned EOF'
                go to 50
           end if
           k = fgetc(TM1,ch)
           if (k .eq. EOF) then
                write (*,*) '?fgetc(TM1,ch) returned EOF at offset ',
     x               -offset,' from end'
                go to 50
           end if
           k = fputc(TM2,ch)
   30      continue
C
C    Copy TM2 in reverse order to stdout.
C
      call fflush(TM2)
      close (unit = TM2)
      open (unit=TM2,access='sequential',form='formatted',
     x     status='old',file='tstio9.tm2')
      rewind TM2
      offset = 0
      k = fseek(TM2,offset,2)
      lenfil = ftell(TM2)
      write (0,*) ' TM2 has ',lenfil,' bytes'
           do 40 offset = 1,lenfil
           k = fseek(TM2,-offset,2)
           if (k .eq. EOF) then
                write (*,*) '?fseek(TM2,',offset,',2) returned EOF'
                go to 50
           end if
           k = fgetc(TM2,ch)
           if (k .eq. EOF) then
                write (*,*) '?fgetc(TM2,ch) returned EOF at offset ',
     x               -offset,' from end'
                go to 50
           end if
           k = fputc(STDOUT,ch)
   40      continue
C
   50 close (unit = TM1)
      close (unit = TM2)
      stop
      end
