divert(-1)# discard spurious whitespace
# ----------------------------------------------------------------------
#	    M4 macro definitions for Unix VAX assembler, AS
#
# Note: M4 reserves the following names:
#
#	define, undefine, ifdef, changequote, divert, undivert,
#	divnum, dnl, ifelse, incr, eval, len, index, substr,
#	translit, include, sinclude, syscmd, maketemp, errprint,
#	dumpdef
#
# DO NOT USE  THEM  AS  LOCAL  VARIABLE/PROCEDURE  NAMES  --  they  will
# disappear from the output.
#
# Although generally the source code containing macro definitions can be
# piped directly into M4 whose output in turn is piped directly  to  the
# assembler,   some  care has nevertheless been taken to prettyprint the
# output assembly code from M4 in case it becomes necessary to refer  to
# it for debugging purposes.
#
# Internal   macros  are  prefixed  by  a double underscore so as not to
# conflict with user-defined names.
#
# Comment lines beginning with a single number sign are discarded by M4,
# and so may be used to document macro definitions.
#
# Since   Unix  requires  lower  case  input for language keywords, user
# macros are defined in upper case so as to be  distinct  from  language
# names.
#
# The  Unix VAX assembler is essentially undocumented, and the following
# points were gleaned from the PDP-11 assembler writeup and  experiments
# with compiler output:
#
# * Where   VAX  VMS  uses  #nnn  and  @off(reg),  Unix  uses $nnn and
#   *off(reg).  These were changed because  #  and  @  were  used  for
#   terminal editing on old Unix systems.
#
# * All integer constants are DECIMAL, unless they have a leading zero
#   digit, in which case they are OCTAL.   Hexadecimal  constants  are
#   available in the form 0xnnnn (n = 0..9,a-f).
#
# * All  opcodes and  register names are lower case, but are otherwise
#   identical to VAX VMS.
#
# * Whereas the VMS macro processor does not permit macro  definitions
#   as symbolic  register offsets (e.g. argn(ap)), M4 is more powerful
#   and lets one write argn which  expands  into  nnn(ap).   With  the
#   f77/C  calling conventions, the n-th argument is found at 4*n(ap).
#   The argument count is at 0(ap), but it cannot  be  tested  for  an
#   exact match because of the extra arguments introduced by character
#   data.
#
# * Arguments are passed on the stack with  routine  calls  by  "calls
#   argcnt,proc"  and  for  each  character  argument, one  additional
#   argument is appended which is a CONSTANT specifying the  character
#   string  length.     All  other  stack  entries  are  ADDRESSES  of
#   arguments.
#
# * Although  it  is  not  documented  as  such,  M4  will   not    do
#   substitutions  in  a  line  following  a  number sign; if  this is
#   required, the number sign must be braced: {#}.
#
# * The VMS assembler  permits  instruction  length  modifiers  to  be
#   omitted,  so  that  one  can  write "subb" and have the  assembler
#   generate either "subb2" or  "subb3",  as  appropriate.   The  Unix
#   assembler REQUIRES the length modifiers.
#
# {11-Sep-84}
# ----------------------------------------------------------------------

# Macro protection brackets are { and }, not ` and '.

changequote({,})

# ----------------------------------------------------------------------
# Unix C/f77 procedure entry:
#
#	PROC(procname,{register-mask-list},{{arg1},{arg2},...,{arg9}})
#
# The register mask list contains decimal numbers  of  registers  to  be
# saved; these should be in the range 2..11, or the symbol  ALL  to save
# registers 2..11.
#
# Because of M4 limitations, only 9 arguments may be declared.  They may
# subsequently be referenced by and will expand into nnn(ap).  The extra
# level  of  protection  brackets around each argument can be omitted if
# they never appear elsewhere in a argument list.
#
define(PROC,{
{.text}
.globl	_{}$1{}_
.globl	$1{}_

_{}$1{}_:				# Unix entry point
$1{}_:					# VMS entry point

ifelse({$2},ALL,{.word	0xffc},{__mask($2)})
__arglist($3)
define({__arglist__},{{$3}})
})

define(ENDPROC,{__undeflist({{__arglist__}})undefine({__arglist__})})

define(END,)

define(SUBTITLE,{
# ======================================================================
# $1
# ======================================================================
})

define(TITLE,{
# 
# ======================================================================
# $1
# ======================================================================
})


# -------------------- I N T E R N A L	 M A C R O S -------------------
# ----------------------------------------------------------------------

define(__undeflist,{undefine({$1})undefine({$2})undefine({$3})undefine({$4})undefine({$5})undefine({$6})undefine({$7})undefine({$8})undefine({$9})})

# ----------------------------------------------------------------------

define(__define,undefine({{$1}}){define({$1},$2)})

# ----------------------------------------------------------------------

define(__bitval,{ifelse($1,,0,{ifelse(eval((2 <= $1) && ($1 <= 11)),1,eval(2 ** $1),{errprint(Register $1 out of range 2..11)})})})

# ----------------------------------------------------------------------

define(__mask,.word	{eval(__bitval($1)+__bitval($2)+__bitval($3)+__bitval($4)+__bitval($5)+__bitval($6)+__bitval($7)+__bitval($8)+__bitval($9))			# Entry mask for register(s) $1 $2 $3 $4 $5 $6 $7 $8 $9})

# ----------------------------------------------------------------------

define(__arglist,{
__arg({$1},4)__arg({$2},8)__arg({$3},12)__arg({$4},16)__arg({$5},20)__arg({$6},24)__arg({$7},28)__arg({$8},32)__arg({$9},36)})

# ----------------------------------------------------------------------

define(__arg,{ifelse($1,,,__define({$1},$2(ap)){#} Argument ``{$1}'' at $2(ap)
)})dnl

# ----------------------------------------------------------------------

# turn output back on
divert{}dnl
